extern crate coap;

use std::io::ErrorKind;
use coap::{CoAPClient, CoAPOption, CoAPRequest, IsMessage, MessageType};
use coap::message::header::Requests;

fn main() {
    // let addr = "127.0.0.1:5683";
    let url = "127.0.0.1:9683";
    let endpoint = "servicediscovery/publish";

    let client = CoAPClient::new(url).unwrap();
    let mut request = CoAPRequest::new();
    request.set_code("0.02");
    // let mut header = request.get_mut_header();
    // header = Requests::Post;
    request.set_version(1);
    //request.set_type(Requests::Post);
    // request.set_code("0.01");
    // request.set_message_id(1);
    // request.set_token(vec![0x51, 0x55, 0x77, 0xE8]);

    //
    let service_description = "
  {
    \"name\": \"crazy-827635ef\",
    \"type\": \"kalle._coap-json._udp\",
    \"host\": \"[fdfd::ff]\",
    \"port\": \"5683\",
    \"domain\": \"unknown\",
    \"properties\": {
      \"property\": [
        {
          \"name\": \"version\",
          \"value\": \"1.0\"
        },
        {
          \"name\": \"path\",
          \"value\": \"/palletAvailable\",
          \"loc\": \"Station-01\"
        }
      ]
    }
  }";
    request.set_payload(service_description.to_string().into_bytes());
    request.add_option(CoAPOption::UriPath, endpoint.to_string().into_bytes());
    println!("{:?}", request);

    client.send(&request).unwrap();
    println!("Client request: coap://{}{}", url, endpoint);

    match client.receive() {
        Ok(response) => {
            println!(
                "Server reply: {}",
                String::from_utf8(response.message.payload).unwrap()
            );
        }
        Err(e) => {
            match e.kind() {
                ErrorKind::WouldBlock => println!("Request timeout"), // Unix
                ErrorKind::TimedOut => println!("Request timeout"),   // Windows
                _ => println!("Request error: {:?}", e),
            }
        }
    }
}
